
/*
xpvox copyright (c) 2005 Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _XPVOX_H_
#define _XPVOX_H_

#define USE_FREOPEN
//#define TIMING_CHECKS

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <pwd.h>
#include <string.h>
#include "getopt.h"
#include "strings.h"
#include <signal.h>
#include <pthread.h>
#include <fcntl.h>
#include <stdint.h>

//#include <linux/soundcard.h>
#include <sys/soundcard.h>

#ifdef TIMING_CHECKS
#include <sys/time.h>
#endif // TIMING_CHECKS

#include <sys/ioctl.h>
#include <math.h>
#include <ctype.h>
#include <sys/wait.h>

#include <unistd.h> /* for libc5 */
#include <sys/io.h> /* for glibc */


#include <forms.h>

#include "audio.h"
#include "keys.h"
#include "sounds.h"

/**** Forms and Objects ****/
typedef struct
	{
	FL_FORM *xpvox;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *main_form_text;
	FL_OBJECT *beacon_sound_button;
	FL_OBJECT *beacon_period_time_input_field;
	FL_OBJECT *timed_play_button;
	FL_OBJECT *timed_play_input_field;
	FL_OBJECT *play_one_per_day_next_text;
	FL_OBJECT *play_one_per_day_button;
	FL_OBJECT *play_one_per_day_next_input_field;
	FL_OBJECT *transmit_button;
	FL_OBJECT *audio_peak_indicator_slider;
	FL_OBJECT *threshold_slider;
	FL_OBJECT *on_time_slider;
	FL_OBJECT *off_time_slider;
	FL_OBJECT *off_time_x10_button;
	FL_OBJECT *agc_button;
	FL_OBJECT *transmission_inhibit_button;
	FL_OBJECT *rts_state_indicator;
	FL_OBJECT *transmission_lock_button;
	FL_OBJECT *sound_browser;
	FL_OBJECT *sound_browser_text;
	FL_OBJECT *add_sound_button;
	FL_OBJECT *show_sounds_without_path_button;
	FL_OBJECT *delete_sound_button;
	FL_OBJECT *log_button;
	FL_OBJECT *in_sound_button;
	FL_OBJECT *out_sound_button;
	FL_OBJECT *play_sound_button;
	FL_OBJECT *stop_sound_button;
	FL_OBJECT *use_xpequ_button;
	FL_OBJECT *audio_input_device_select_button;
	FL_OBJECT *audio_input_text;
	FL_OBJECT *audio_output_device_select_button;
	FL_OBJECT *audio_output_text;
	FL_OBJECT *exit_button;
	} FD_xpvox;

extern FD_xpvox * create_form_xpvox(void);

#define READSIZE 4096

/* for position browser display */
#define SHOW_TOP			0
#define SHOW_SAME_POSITION	1
#define SHOW_UNREAD_AT_TOP	2
#define SHOW_BOTTOM			3
#define SHOW_SELECTED		4

/* for status roger_sound_browser, use 1, 2, 4... etc  */
#define NEW_ENTRY       0
#define LEAD_IN			1
#define LEAD_OUT		2

/* for audio file player */
#define LEAD_IN_SOUND		1
#define LEAD_OUT_SOUND		2
#define SELECTED_SOUND		3
#define AUTO_PLAY_SOUND		4

/* for audio devices */
#define AUDIO_DEVICE_FIRST	0
#define AUDIO_DEVICE_LAST	3

int debug_flag;
struct passwd *userinfo;
char *user_name;
char *home_dir;
double threshold;
char *serial_device;
char *audio_input_device;
char *audio_output_device;
int output_flag;
int transmit_flag;
int high_samples;
int low_samples;
double on_milli_seconds;
double off_milli_seconds;
double milli_seconds_per_sample;
int transmission_inhibit_flag;
int transmission_lock_flag;
double audio_peak_level;
double audio_current_level;
double minimum_db;
int set_mixer_flag;
char *sound_dir;
int selected_sound;
int rts_is_on_flag;
int rts_requested_on_flag;
int force_transmit_on_flag, force_transmit_off_flag;
int playing_flag;
int audio_input_device_number;
int audio_output_device_number;
int play_lead_in_flag;
int play_lead_out_flag;
int beacon_flag;
int beacon_period_time;
int alarm_hour, alarm_minute;
char weekday[20];
char month[20];
int monthday, hour, minute, second, year;
int time_match_flag;
int auto_transmit_flag;
int auto_play_sequence_flag;
int auto_play_sequence_number;
int show_picture_flag;
int play_one_per_day_flag;
int output_no_silence_flag;
int no_io_flag;
int show_sounds_without_path_flag;
int log_flag;
char *log_filename;
int player_sound;
int off_time_10x_flag;
int old_rts_is_on_flag;
int agc_flag;
int agc_init_flag;
double agc_level;
double agc_multiplier;
int use_xpequ_flag;

#ifdef TIMING_CHECKS
struct timeval *start_timeval;
struct timeval *current_timeval;
#endif // TIMING_CHECKS

#define DEFAULT_AUDIO_INPUT_DEVICE_NUMBER	0
#define DEFAULT_AUDIO_OUTPUT_DEVICE_NUMBER	1
#define DEFAULT_SERIAL_PORT					"/dev/cua0"
#define DEFAULT_THRESHOLD					-33.0
#define DEFAULT_DSP_SPEED					44100
#define DEFAULT_ON_TIME						1.5
#define DEFAULT_OFF_TIME					1500.0
#define DEFAULT_BEACON_PERIOD_TIME			60

/* AGC */
#define AGC_MAX_GAIN						50
#define AGC_INIT_GAIN_INCREASE_SPEED		.001
#define AGC_GAIN_INCREASE_SPEED				.000001

#define PROG_VERSION "xpvox-0.9.5"

#include "xpvox_proto.h"

#endif /* _XPVOX_H_ */

